package gg.malloc.defense.engine;

import gg.malloc.defense.model.Progress;

public class BombFuse implements Progress {
  int m_bombFuseCount = 0;
  int m_bombFuseTarget = 10;

  public double toDouble() {
    return Math.max(0.0, Math.min(1.0, (double)m_bombFuseCount / (double)m_bombFuseTarget));
  }

  public boolean isLit() {
    return m_bombFuseCount > 0;
  }

  public boolean isExploded() {
    return m_bombFuseCount > m_bombFuseTarget;
  }

  public void reset() {
    m_bombFuseCount = 0;
  }

  public void tickLit() {
    m_bombFuseCount += 1;
  }

  public void tickDecay() {
    m_bombFuseCount -= 1;
  }

  public int value() {
    return m_bombFuseCount;
  }

  public int maximum() {
    return m_bombFuseTarget;
  }
}
