package gg.malloc.defense.engine;

import gg.malloc.defense.model.Game;
import gg.malloc.defense.model.Progress;
import gg.malloc.defense.model.State;

public class GameState implements State {
  GameRunner m_runner;
  WaveManager m_waves;
  Game m_game;
  MobManager m_mobs;
  BombFuse m_fuse;
  PlayerManager m_players;

  public GameState(GameRunner runner, WaveManager waves, Game game, MobManager mobs, BombFuse fuse, PlayerManager players) {
    m_runner = runner;
    m_waves = waves;
    m_game = game;
    m_mobs = mobs;
    m_fuse = fuse;
    m_players = players;
  }

  public GameRunner.Stage getStage() {
    return m_runner.getStage();
  }

  public Progress fuseProgress() {
    return m_fuse;
  }

  public Progress waveProgress() {
    return m_waves.asProgress();
  }

  public Progress mobProgress() {
    return m_mobs;
  }

  public Progress playerReadyProgress() {
    return m_players.readyProgress();
  }
}
