package gg.malloc.defense.engine;

import gg.malloc.defense.Plugin;
import org.bukkit.scheduler.BukkitTask;

public class TickTask {
  Runnable m_runnable;
  int m_interval;
  BukkitTask m_task = null;
  Plugin m_plugin;
  boolean m_cancelled = false;

  public TickTask(Plugin plugin, Runnable runnable, int interval) {
    m_plugin = plugin;
    m_runnable = runnable;
    m_interval = interval;
  }

  public void start() {
    m_cancelled = false;
    if (m_task == null) {
      tick();
    }
  }

  private void tick() {
    m_runnable.run();
    if (!m_cancelled) {
      m_task = m_plugin.getServer().getScheduler().runTaskLater(m_plugin, () -> {tick();}, m_interval);
    }
  }

  void stop() {
    m_cancelled = true;
    if (m_task != null) {
      m_task.cancel();
      m_task = null;
    }
  }
}
